sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=151
left=100
sizeHControl=0
sizeVControl=0
tile=1
caption="Fighter"
End CompInit
Dim display as gadget
display = MakeComponent("gadget",form1)
CompInit display
proto="display"
width=450
height=250
visible=1
End CompInit
display.name="display"
form1.width=320
form1.height=280
form1.name="form1"
Dim gamecontrol as timer
gamecontrol = MakeComponent("timer","app")
CompInit gamecontrol
proto="gamecontrol"
End CompInit
gamecontrol.name="gamecontrol"
Dim playera_animation as timer
playera_animation = MakeComponent("timer","app")
CompInit playera_animation
proto="playera_animation"
End CompInit
playera_animation.name="playera_animation"
Dim playerb_animation as timer
playerb_animation = MakeComponent("timer","app")
CompInit playerb_animation
proto="playerb_animation"
End CompInit
playerb_animation.name="playerb_animation"
Dim computerplayer as timer
computerplayer = MakeComponent("timer","app")
CompInit computerplayer
proto="computerplayer"
End CompInit
computerplayer.name="computerplayer"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

DIM gameover AS integer

DIM pause AS integer

DIM height AS integer
	height = 80
	
DIM bgcolor AS long
	bgcolor = BLACK
	
playera_animation.interval = 6
playera_animation.enabled = TRUE
playerb_animation.interval = 6
playerb_animation.enabled = TRUE

STRUCT player
	DIM pos AS integer
	DIM health AS integer
	DIM animphase AS integer
	DIM animation AS string
END STRUCT

DIM playera AS STRUCT player
	playera.pos = 80
	playera.health = 150
	
DIM playerb AS STRUCT player
	playerb.pos = 300
	playerb.health = 150

gamecontrol.interval = 6
gamecontrol.enabled = TRUE

computerplayer.interval = 10
computerplayer.enabled = TRUE

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub display_draw(self as gadget)

	self.DrawRect( 0, 0, self.width, self.height, BLACK)
	
	'dummy
	self.DrawImage( getComplex(4), playera.pos, height)
	self.DrawImage( getComplex(14), playerb.pos, height)

end sub

sub timer1_ring(self as timer)

'IF dummy < 10 THEN
'	display.DrawImage( getComplex(dummy), 200, 80)
'	dummy = dummy + 1
'ELSE
'	dummy = 0
'END IF

end sub

sub display_mouse(self as gadget, action as integer, flag as integer, X as integer, Y as integer, modifier as integer)

IF action = 1 THEN
	IF gameover = TRUE THEN
		pause = FALSE
		form1.caption = "Fighter"
		playera.health = 100
		playerb.health = 100
		playera.pos = 80
		playerb.pos = 300
		gameover = FALSE
		playera_animation.enabled = TRUE
		computerplayer.enabled = TRUE
		display_draw( display)
	ELSE IF pause = FALSE THEN
		pause = TRUE
		gamecontrol.enabled = FALSE
		computerplayer.enabled = FALSE
		'playera_animation.enabled  = FALSE
		form1.caption = "PAUSE"
	ELSE
		pause = FALSE
		gamecontrol.enabled = TRUE
		computerplayer.enabled = TRUE
		'playera_animation.enabled = TRUE
		form1.caption = "Fighter"
	END IF
END IF

end sub

function display_char(self as gadget, action as integer, char as integer, modifierState as integer) as integer

IF pause = FALSE
	IF playera.animation = "" THEN
		SELECT CASE char
			CASE asc("a") 'step back
				playera.animation = "step back"
			
			CASE asc("d") 'step forward
				playera.animation = "step forward"
	
			CASE asc(" ") 'kick
				playera.animation = "kick"
		
			CASE asc("c") 'punch
				playera.animation = "punch"
				
			CASE asc("h") 'simulates beeing hit
				playera.animation = "hit"
				
			CASE asc("k") 'simulates beeing knocked off
				playera.animation = "ko"
		
		END SELECT
	END IF
END IF

end function

sub playera_animation_ring(self as timer)

SELECT CASE playera.animation
	CASE "step back"
		IF playera.animphase = 0 THEN
			display.DrawRect( playera.pos, height, playera.pos + 60, height + 90, bgcolor)
			playera.pos = playera.pos - 10
			display.DrawImage( getComplex(7), playera.pos, height)
				playera.animphase = 1
		ELSE IF playera.animphase = 1 THEN
			display.DrawRect( playera.pos, height, playera.pos + 60, height + 90, bgcolor)
			display.DrawImage( getComplex(4), playera.pos, height)
				playera.animphase = 0
				playera.animation = ""
		END IF
		
	CASE "step forward"
		IF playera.animphase = 0 THEN
			display.DrawRect( playera.pos, height, playera.pos + 60, height + 100, bgcolor)
			playera.pos = playera.pos + 10
			display.DrawImage( getComplex(7), playera.pos, height)
				playera.animphase = 1
		ELSE IF playera.animphase = 1 THEN
			display.DrawRect( playera.pos, height, playera.pos + 60, height + 100, bgcolor)
			display.DrawImage( getComplex(4), playera.pos, height)
			playera.animphase = 0
			playera.animation = ""
		END IF
				
	CASE "kick"
		IF playera.animphase = 0 THEN
			display.DrawRect( playera.pos, height, playera.pos + 80, height + 80, bgcolor)
			display.DrawImage( getComplex(8), playera.pos, height)
				playera.animphase = 1
			REM check kick etc
			IF playerb.pos <= playera.pos + 100 THEN
				IF playerb.health > 11 THEN
					playerb.animation = "hit"
					playerb.health = playerb.health - 10
				ELSE
					playerb.animation = "ko"
					playerb.health = 0
					gameover = TRUE
				END IF
			END IF				
		ELSE IF playera.animphase = 1 THEN
			display.DrawRect( playera.pos, height, playera.pos + 100, height + 80, bgcolor)
			display.DrawImage( getComplex(4), playera.pos, height)
				playera.animphase = 0
				playera.animation = ""
		END IF

	CASE "punch"
		IF playera.animphase = 0 THEN
			display.DrawRect( playera.pos, height, playera.pos + 100, height + 100, bgcolor)
			display.DrawImage( getComplex(6), playera.pos, height)
				playera.animphase = 1
			REM check punch etc
			IF playerb.pos <= playera.pos + 70 THEN
				IF playerb.health > 6 THEN
					playerb.animation = "hit"
					playerb.health = playerb.health - 5
				ELSE
					playerb.animation = "ko"
					playerb.health = 0
					gameover = TRUE
				END IF
			END IF
		ELSE IF playera.animphase = 1 THEN
			display.DrawRect( playera.pos, height, playera.pos + 100, height + 100, bgcolor)
			display.DrawImage( getComplex(4), playera.pos, height)
				playera.animphase = 0
				playera.animation = ""
		END IF
		
	CASE "hit"
		IF playera.animphase = 0 THEN
			display.DrawRect( playera.pos, height, playera.pos + 70, height + 100, bgcolor)
			display.DrawImage( getComplex(9), playera.pos, height)
				playera.animphase = 1
		ELSE IF playera.animphase = 1 THEN
			display.DrawRect( playera.pos, height, playera.pos + 70, height + 100, bgcolor)
			display.DrawImage( getComplex(4), playera.pos, height)
				playera.animphase = 0
				playera.animation = ""
		END IF
		
	CASE "ko"
		IF playera.animphase = 0 THEN
			display.DrawRect( playera.pos, height, playera.pos + 60, height + 100, bgcolor)
			display.DrawImage( getComplex(10), playera.pos, height + 27)
		'		playera.animphase = 1
		'ELSE IF playera.animphase = 1 THEN
		'	display.DrawRect( playera.pos, height, playera.pos + 60, height + 100, bgcolor)
		'	display.DrawImage( getComplex(11), playera.pos, height)
				playera.animphase = 0
				playera.animation = ""
		END IF
		
END SELECT

end sub

sub playerb_animation_ring(self as timer)

SELECT CASE playerb.animation
	CASE "step back"
		IF playerb.animphase = 0 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 60, height + 90, bgcolor)
			playerb.pos = playerb.pos + 10
			display.DrawImage( getComplex(17), playerb.pos, height)
				playerb.animphase = 1
		ELSE IF playerb.animphase = 1 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 60, height + 90, bgcolor)
			display.DrawImage( getComplex(14), playerb.pos, height)
				playerb.animphase = 0
				playerb.animation = ""
		END IF
		
	CASE "step forward"
		IF playerb.animphase = 0 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 60, height + 100, bgcolor)
			playerb.pos = playerb.pos - 10
			display.DrawImage( getComplex(17), playerb.pos, height)
				playerb.animphase = 1
		ELSE IF playerb.animphase = 1 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 60, height + 100, bgcolor)
			display.DrawImage( getComplex(14), playerb.pos, height)
			playerb.animphase = 0
			playerb.animation = ""
		END IF
				
	CASE "kick"
		IF playerb.animphase = 0 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 80, height + 100, bgcolor)
			display.DrawImage( getComplex(18), playerb.pos, height)
				playerb.animphase = 1
			REM check kick etc
			IF playerb.pos <= playera.pos + 100 THEN
				IF playera.health > 11 THEN
					playera.animation = "hit"
					playera.health = playera.health - 10
				ELSE
					playera.animation = "ko"
					playera.health = 0
					gameover = TRUE
				END IF
			END IF				
		ELSE IF playerb.animphase = 1 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 100, height + 100, bgcolor)
			display.DrawImage( getComplex(14), playerb.pos, height)
				playerb.animphase = 0
				playerb.animation = ""
		END IF

	CASE "punch"
		IF playerb.animphase = 0 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 100, height + 100, bgcolor)
			display.DrawImage( getComplex(16), playerb.pos, height)
				playerb.animphase = 1
			REM check punch etc
			IF playerb.pos <= playera.pos + 70 THEN
				IF playera.health > 6 THEN
					playera.animation = "hit"
					playera.health = playera.health - 5
				ELSE
					playera.animation = "ko"
					playera.health = 0
					gameover = TRUE
				END IF
			END IF
		ELSE IF playerb.animphase = 1 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 100, height + 100, bgcolor)
			display.DrawImage( getComplex(14), playerb.pos, height)
				playerb.animphase = 0
				playerb.animation = ""
		END IF
				
	CASE "hit"
		IF playerb.animphase = 0 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 70, height + 100, bgcolor)
			display.DrawImage( getComplex(19), playerb.pos, height)
				playerb.animphase = 1
		ELSE IF playerb.animphase = 1 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 70, height + 100, bgcolor)
			display.DrawImage( getComplex(14), playerb.pos, height)
				playerb.animphase = 0
				playerb.animation = ""
		END IF
		
	CASE "ko"
		IF playerb.animphase = 0 THEN
			display.DrawRect( playerb.pos, height, playerb.pos + 60, height + 100, bgcolor)
			display.DrawImage( getComplex(21), playerb.pos, height + 27)
		'		playera.animphase = 1
		'ELSE IF playerb.animphase = 1 THEN
		'	display.DrawRect( playera.pos, height, playera.pos + 60, height + 100, bgcolor)
		'	display.DrawImage( getComplex(11), playera.pos, height)
				playerb.animphase = 0
				playerb.animation = ""
		END IF
		
END SELECT

end sub

sub gamecontrol_ring(self as timer)

IF gameover <> TRUE THEN
	display.DrawRect( 10, 10, 350, 35, bgcolor)
	display.DrawText( "player A health: " + str(playera.health) + " / Player B health: " + str(playerb.health), 10, 10, LIGHT_RED, "URW Roman", 12, 0)
END IF

IF gameover = TRUE AND form1.caption <> "GAME OVER" THEN
		playera_animation.enabled  = FALSE
		computerplayer.enabled = FALSE
		form1.caption = "GAME OVER"
			display.DrawRect( 10, 10, 300, 25, bgcolor)
			display.DrawText( "player A health: " + str(playera.health) + " / Player B health: " + str(playerb.health), 10, 10, LIGHT_RED, "URW Roman", 12, 0)
			
		IF playera.health <= 0 THEN
			display.DrawText( "Sorry, Computer wins", 10, 200, LIGHT_RED, "URW Roman", 20, 0)
		ELSE
			display.DrawText( "Heh, you did it!", 10, 200, LIGHT_RED, "URW Roman", 20, 0)
		END IF
		
		display.DrawText( "Click to play again", 10, 230, LIGHT_RED, "URW Roman", 20, 0)
		
'ELSE
'		playera_animation.enabled = TRUE
'		form1.caption = "Fighter"
END IF

end sub

sub computerplayer_ring(self as timer)

IF playerb.animation = "" THEN
	IF playerb.pos - playera.pos <= 70 THEN
		playerb.animation = "kick"
	ELSE IF playerb.pos - playera.pos <= 50 THEN
		playerb.animation = "punch"
	ELSE IF playerb.pos - playera.pos > 70
		playerb.animation = "step forward"
	'ELSE
	'	playerb.animation = "step forward"
	END IF
END IF

end sub

